Package org.apache.sis.metadata.iso.identification

# Class DefaultServiceIdentification

Object
AbstractMetadata
ModifiableMetadata
ISOMetadata
AbstractIdentification
DefaultServiceIdentification

All Implemented Interfaces:
  `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `Identification`, `ServiceIdentification`

public class DefaultServiceIdentification extends AbstractIdentification implements ServiceIdentification
Identification of capabilities which a service provider makes available to a service user through a set of interfaces that define a behaviour. The following properties are mandatory or conditional (i.e. mandatory under some circumstances) in a well-formed metadata according ISO 19115:
`SV_ServiceIdentification` `├─citation………………………………………` Citation data for the resource(s). `│ ├─title……………………………………` Name by which the cited resource is known. `│ └─date………………………………………` Reference date for the cited resource. `├─abstract………………………………………` Brief narrative summary of the content of the resource(s). `├─serviceType………………………………` A service type name. For example: "view", "download", or "invoke". `├─coupledResource……………………` Further description of the data coupling in the case of tightly coupled services. `├─couplingType……………………………` Type of coupling between service and associated data (if exist). `├─extent……………………………………………` Bounding polygon, vertical, and temporal extent of the dataset. `│ ├─description……………………` The spatial and temporal extent for the referring object. `│ ├─geographicElement……` Geographic component of the extent of the referring object. `│ ├─temporalElement…………` Temporal component of the extent of the referring object. `│ └─verticalElement…………` Vertical component of the extent of the referring object. `└─topicCategory…………………………` Main theme(s) of the dataset.

## Limitations

- Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
- Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.

Since:
  0.5
See Also:
  - Serialized Form

Defined in the `sis-metadata` module

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class ModifiableMetadata

  `ModifiableMetadata​.State`

- ## Field Summary

  ### Fields inherited from class ISOMetadata

  `identifiers`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultServiceIdentification()`
  Constructs an initially empty service identification.
  `DefaultServiceIdentification(ServiceIdentification object)`
  Constructs a new instance initialized with the values from the specified metadata object.
  `DefaultServiceIdentification(GenericName serviceType, Citation citation, CharSequence abstracts)`
  Constructs a service identification initialized to the specified values.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultServiceIdentification`
  `castOrCopy(ServiceIdentification object)`
  Returns a SIS metadata implementation with the values of the given arbitrary implementation.
  `StandardOrderProcess`
  `getAccessProperties()`
  Returns information about the availability of the service.
  `Collection<DefaultOperationChainMetadata>`
  `getContainsChain()`
  Provides information about the chain applied by the service.
  `Collection<DefaultOperationMetadata>`
  `getContainsOperations()`
  Provides information about the operations that comprise the service.
  `Collection<DefaultCoupledResource>`
  `getCoupledResources()`
  Returns further description(s) of the data coupling in the case of tightly coupled services.
  `CodeList<?>`
  `getCouplingType()`
  Returns type of coupling between service and associated data (if exist).
  `Collection<Citation>`
  `getOperatedDatasets()`
  Returns the reference(s) to the resource on which the service operates.
  `Collection<DataIdentification>`
  `getOperatesOn()`
  Provides information on the resources that the service operates on.
  `Collection<Citation>`
  `getProfiles()`
  Returns the profile(s) to which the service adheres.
  `Collection<Citation>`
  `getServiceStandards()`
  Returns the standard(s) to which the service adheres.
  `GenericName`
  `getServiceType()`
  Returns a service type name.
  `Collection<String>`
  `getServiceTypeVersions()`
  Returns the versions of the service.
  `void`
  `setAccessProperties(StandardOrderProcess newValue)`
  Sets information about the availability of the service.
  `void`
  `setContainsChain(Collection<? extends DefaultOperationChainMetadata> newValues)`
  Sets the information about the chain applied by the service.
  `void`
  `setContainsOperations(Collection<? extends DefaultOperationMetadata> newValues)`
  Sets information(s) about the operations that comprise the service.
  `void`
  `setCoupledResources(Collection<? extends DefaultCoupledResource> newValues)`
  Sets further description(s) of the data coupling in the case of tightly coupled services.
  `void`
  `setCouplingType(CodeList<?> newValue)`
  Sets the type of coupling between service and associated data.
  `void`
  `setOperatedDatasets(Collection<? extends Citation> newValues)`
  Sets the reference(s) to the resource on which the service operates.
  `void`
  `setOperatesOn(Collection<? extends DataIdentification> newValues)`
  Sets the information on the resources that the service operates on.
  `void`
  `setProfiles(Collection<? extends Citation> newValues)`
  Sets the profile(s) to which the service adheres.
  `void`
  `setServiceStandards(Collection<? extends Citation> newValues)`
  Sets the standard(s) to which the service adheres.
  `void`
  `setServiceType(GenericName newValue)`
  Sets the service type name.
  `void`
  `setServiceTypeVersions(Collection<? extends String> newValues)`
  Sets the versions of the service.

  ### Methods inherited from class AbstractIdentification

  `castOrCopy, getAbstract, getAdditionalDocumentations, getAggregationInfo, getAssociatedResources, getCitation, getCredits, getDescriptiveKeywords, getExtents, getGraphicOverviews, getPointOfContacts, getProcessingLevel, getPurpose, getResourceConstraints, getResourceFormats, getResourceMaintenances, getResourceSpecificUsages, getSpatialRepresentationTypes, getSpatialResolutions, getStatus, getTopicCategories, setAbstract, setAdditionalDocumentations, setAggregationInfo, setAssociatedResources, setCitation, setCredits, setDescriptiveKeywords, setExtents, setGraphicOverviews, setPointOfContacts, setProcessingLevel, setPurpose, setResourceConstraints, setResourceFormats, setResourceMaintenances, setResourceSpecificUsages, setSpatialRepresentationTypes, setSpatialResolutions, setStatus, setTopicCategories`

  ### Methods inherited from class ISOMetadata

  `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier, transitionTo`

  ### Methods inherited from class ModifiableMetadata

  `checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, deepCopy, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, writeCollection, writeList, writeMap, writeSet`

  ### Methods inherited from class AbstractMetadata

  `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface Identification

  `getAbstract, getAggregationInfo, getCitation, getCredits, getDescriptiveKeywords, getGraphicOverviews, getPointOfContacts, getPurpose, getResourceConstraints, getResourceFormats, getResourceMaintenances, getResourceSpecificUsages, getStatus`

- ## Constructor Details

  - ### DefaultServiceIdentification

    public DefaultServiceIdentification()
    Constructs an initially empty service identification.

  - ### DefaultServiceIdentification

    public DefaultServiceIdentification(GenericName serviceType, Citation citation, CharSequence abstracts)
    Constructs a service identification initialized to the specified values.
    Parameters:
      `serviceType` - service type name.
      `citation` - citation data for the resource(s).
      `abstracts` - brief narrative summary of the content of the resource(s).

  - ### DefaultServiceIdentification

    public DefaultServiceIdentification(ServiceIdentification object)
    Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, since the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the metadata to copy values from, or `null` if none.
    See Also:
      - `castOrCopy(ServiceIdentification)`

- ## Method Details

  - ### castOrCopy

    public static DefaultServiceIdentification castOrCopy(ServiceIdentification object)
    Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
    - If the given object is `null`, then this method returns `null`.
    - Otherwise if the given object is already an instance of `DefaultServiceIdentification`, then it is returned unchanged.
    - Otherwise a new `DefaultServiceIdentification` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, since the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getServiceType

    @UML(identifier="serviceType", obligation=MANDATORY, specification=ISO_19115) public GenericName getServiceType()
    Returns a service type name.
    Examples: "discovery", "view", "download", "transformation", or "invoke"
    Returns:
      a service type name.

  - ### setServiceType

    public void setServiceType(GenericName newValue)
    Sets the service type name.
    Parameters:
      `newValue` - the new service type name.

  - ### getServiceTypeVersions

    @UML(identifier="serviceTypeVersion", obligation=OPTIONAL, specification=ISO_19115) public Collection<String> getServiceTypeVersions()
    Returns the versions of the service.
    Returns:
      the versions of the service.

  - ### setServiceTypeVersions

    public void setServiceTypeVersions(Collection<? extends String> newValues)
    Sets the versions of the service.
    Parameters:
      `newValues` - the new versions of the service.

  - ### getAccessProperties

    @UML(identifier="accessProperties", obligation=OPTIONAL, specification=ISO_19115) public StandardOrderProcess getAccessProperties()
    Returns information about the availability of the service.
    Returns:
      information about the availability of the service, or `null` if none.
    Since:
      0.5

  - ### setAccessProperties

    public void setAccessProperties(StandardOrderProcess newValue)
    Sets information about the availability of the service.
    Parameters:
      `newValue` - the new information about the availability of the service.
    Since:
      0.5

  - ### getCouplingType

    @UML(identifier="couplingType", obligation=CONDITIONAL, specification=ISO_19115) public CodeList<?> getCouplingType()
    Returns type of coupling between service and associated data (if exist).
    Upcoming API change — specialization
    The return type will be changed to the `CouplingType` code list when GeoAPI will provide it (tentatively in GeoAPI 3.1).
    Returns:
      type of coupling between service and associated data, or `null` if none.

  - ### setCouplingType

    public void setCouplingType(CodeList<?> newValue)
    Sets the type of coupling between service and associated data.
    Upcoming API change — specialization
    The argument type will be changed to the `CouplingType` code list when GeoAPI will provide it (tentatively in GeoAPI 3.1). In the meantime, users can define their own code list class as below:

    >     final class UnsupportedCodeList extends CodeList<UnsupportedCodeList> {
    >         private static final List<UnsupportedCodeList> VALUES = new ArrayList<UnsupportedCodeList>();

    >         // Need to declare at least one code list element.
    >         public static final UnsupportedCodeList MY_CODE_LIST = new UnsupportedCodeList("MY_CODE_LIST");

    >         private UnsupportedCodeList(String name) {
    >             super(name, VALUES);
    >         }

    >         public static UnsupportedCodeList valueOf(String code) {
    >             return valueOf(UnsupportedCodeList.class, code);
    >         }

    >         @Override
    >         public UnsupportedCodeList[] family() {
    >             synchronized (VALUES) {
    >                 return VALUES.toArray(new UnsupportedCodeList[VALUES.size()]);
    >             }
    >         }
    >     }

    Parameters:
      `newValue` - the new type of coupling between service and associated data.

  - ### getCoupledResources

    @UML(identifier="coupledResource", obligation=CONDITIONAL, specification=ISO_19115) public Collection<DefaultCoupledResource> getCoupledResources()
    Returns further description(s) of the data coupling in the case of tightly coupled services.
    Upcoming API change — generalization
    The element type will be changed to the `CoupledResource` interface when GeoAPI will provide it (tentatively in GeoAPI 3.1).
    Returns:
      further description(s) of the data coupling in the case of tightly coupled services.

  - ### setCoupledResources

    public void setCoupledResources(Collection<? extends DefaultCoupledResource> newValues)
    Sets further description(s) of the data coupling in the case of tightly coupled services.
    Upcoming API change — generalization
    The element type will be changed to the `CoupledResource` interface when GeoAPI will provide it (tentatively in GeoAPI 3.1).
    Parameters:
      `newValues` - the new further description(s) of the data coupling.

  - ### getOperatedDatasets

    @UML(identifier="operatedDataset", obligation=OPTIONAL, specification=ISO_19115) public Collection<Citation> getOperatedDatasets()
    Returns the reference(s) to the resource on which the service operates.
    Returns:
      reference(s) to the resource on which the service operates.
    Since:
      0.5

  - ### setOperatedDatasets

    public void setOperatedDatasets(Collection<? extends Citation> newValues)
    Sets the reference(s) to the resource on which the service operates.
    Parameters:
      `newValues` - the new reference(s) to the resource on which the service operates.
    Since:
      0.5

  - ### getProfiles

    @UML(identifier="profile", obligation=OPTIONAL, specification=ISO_19115) public Collection<Citation> getProfiles()
    Returns the profile(s) to which the service adheres.
    Returns:
      profile(s) to which the service adheres.
    Since:
      0.5

  - ### setProfiles

    public void setProfiles(Collection<? extends Citation> newValues)
    Sets the profile(s) to which the service adheres.
    Parameters:
      `newValues` - the new profile(s) to which the service adheres.

  - ### getServiceStandards

    @UML(identifier="serviceStandard", obligation=OPTIONAL, specification=ISO_19115) public Collection<Citation> getServiceStandards()
    Returns the standard(s) to which the service adheres.
    Returns:
      standard(s) to which the service adheres.
    Since:
      0.5

  - ### setServiceStandards

    public void setServiceStandards(Collection<? extends Citation> newValues)
    Sets the standard(s) to which the service adheres.
    Parameters:
      `newValues` - the new standard(s) to which the service adheres.
    Since:
      0.5

  - ### getContainsOperations

    @UML(identifier="containsOperations", obligation=OPTIONAL, specification=ISO_19115) public Collection<DefaultOperationMetadata> getContainsOperations()
    Provides information about the operations that comprise the service.
    Upcoming API change — generalization
    The element type will be changed to the `OperationMetadata` interface when GeoAPI will provide it (tentatively in GeoAPI 3.1).
    Returns:
      information about the operations that comprise the service.

  - ### setContainsOperations

    public void setContainsOperations(Collection<? extends DefaultOperationMetadata> newValues)
    Sets information(s) about the operations that comprise the service.
    Upcoming API change — generalization
    The element type will be changed to the `OperationMetadata` interface when GeoAPI will provide it (tentatively in GeoAPI 3.1).
    Parameters:
      `newValues` - the new information(s) about the operations that comprise the service.

  - ### getOperatesOn

    @UML(identifier="operatesOn", obligation=OPTIONAL, specification=ISO_19115) public Collection<DataIdentification> getOperatesOn()
    Provides information on the resources that the service operates on.
    Returns:
      information on the resources that the service operates on.

  - ### setOperatesOn

    public void setOperatesOn(Collection<? extends DataIdentification> newValues)
    Sets the information on the resources that the service operates on.
    Parameters:
      `newValues` - the new information on the resources that the service operates on.

  - ### getContainsChain

    @UML(identifier="containsChain", obligation=OPTIONAL, specification=ISO_19115) public Collection<DefaultOperationChainMetadata> getContainsChain()
    Provides information about the chain applied by the service.
    Upcoming API change — generalization
    The element type will be changed to the `OperationChainMetadata` interface when GeoAPI will provide it (tentatively in GeoAPI 3.1).
    Returns:
      information about the chain applied by the service.
    Since:
      0.5

  - ### setContainsChain

    public void setContainsChain(Collection<? extends DefaultOperationChainMetadata> newValues)
    Sets the information about the chain applied by the service.
    Upcoming API change — generalization
    The element type will be changed to the `OperationChainMetadata` interface when GeoAPI will provide it (tentatively in GeoAPI 3.1).
    Parameters:
      `newValues` - the new information about the chain applied by the service.
    Since:
      0.5